﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace XamGridBindingSourceCase
{
    public class ViewModel : INotifyPropertyChanged
    {

        /// <summary>
        /// Member data
        /// 
        /// Can return a BindingSource *OR* DataView (in m_Data.DataSource)
        /// Change the commented get to swap back and forth
        /// 
        /// </summary>
        private BindingSource m_Data;
        public System.ComponentModel.IBindingList Data
        {
            get { return m_Data as System.ComponentModel.IBindingList; } // BINDINGSOURCE
            //get { return m_Data.DataSource as System.ComponentModel.IBindingList; } // DATAVIEW
        }   
        

        Random r = new Random();

        public event PropertyChangedEventHandler PropertyChanged;

        public ViewModel()
        {


            string Filter = "";

            XamGridBindingSourceCase.Data.SampleData DataTemp = new XamGridBindingSourceCase.Data.SampleData();
            DataView DataViewTemp = new DataView(DataTemp.Sample, Filter, string.Empty, DataViewRowState.CurrentRows);


            // DONT ADD DATA OR IT CONFUSES
            // DIFFERENCE BETWEEN BINDINGSOURCE
            // BEHAVIOR AND DATAVIEW.  THEY BEHAVE
            // A BIT MORE SIMILARLY WHEN YOU
            // ADD DATA (FOR SOME REASON)
            bool AddAndrewsData = false;
            if(AddAndrewsData) AddData(DataTemp);


            // Build BindingSource
            m_Data = new BindingSource();
            m_Data.DataSource = DataViewTemp;
        }


        /// <summary>
        /// Add data
        /// </summary>
        private void AddData(Data.SampleData p_Data)
        {
            for (int i = 0; i < 10; i++)
            {
                p_Data.Sample.AddSampleRow(
                    Label: "Label " + i.ToString(),
                    RandomNumber: r.Next(1000));
            }
        }
    } 
}
